import React, { Component } from 'react'
import ReactDOM from 'react-dom'
import { Row, Col, Pagination, Button, Menu, Dropdown, Icon, message, Alert, Spin,Table,Select } from 'antd'
import TdCmpName from '../common/TdCmpName'
import { SketchPicker } from 'react-color';
import SearchFields from '../common/searchfields/'
// let Handsontable = require('handsontable');
import './newDetail.css'
let Option= Select.Option;

let myRepDetailNewDataBegin = null;
///集合取交集
Array.intersect = function () {
    var result = new Array();
    var obj = {};
    for (var i = 0; i < arguments.length; i++) {
        for (var j = 0; j < arguments[i].length; j++) {
            var str = arguments[i][j];
            if (!obj[str]) {
                obj[str] = 1;
            }
            else {
                obj[str]++;
                if (obj[str] == arguments.length)
                {
                    result.push(str);
                }
            }//end else
        }//end for j
    }//end for i
    return result;
}


class Detail extends Component {
    constructor(props){
        super(props)
        this.instance = null
        this.state = {
            loading: true,
            isError: false,
            errorText: '',
            reportId : props.reportId,
            name: "",
            rep_data: [],
            rep_config: {
                manualColumnResize: "true",
                manualRowResize: "true",
                colWidths: [],
                rowHeights: [],
                mergeCells: []
            },
            db: '',
            guid: "",
            cache_span: '',
            rep_data_new: 2, 
            total:0,
            page:1,
            count:[],
            searchParams:[],
            showElIdRef : "preview" + Math.random().toString() + "",
            selec_data:[],
            link_type: props.linkType?true:false,
            slot:props.slot?props.slot:{},
            style:{
                fontSize:"12px",
                fontWeight:"normal",
                fontStyle:"normal",
                color:"#000",
                fontFamily:"Microsoft YaHei",
                textAlign:"left",
                backgroundColor:"#fff",
                borderStyle:"solid"
            },
            megreconfig:[],
            tableStyle:{
                td:{},
                th:{},
            },
            pageSize:20,
            currentPageData:[]

        }
    }
    handleExportMenuClick(e) {
        let data = {
            id: this.props.reportId,
            type : 'Yes'
        }
        if (e.key === '1') {
            window.location.href = `/general/appbuilder/web/report/replist/export?id=${this.props.reportId}&type=Yes&category=excel&searchParams=${JSON.stringify(this.state.searchParams)}`;
        } else if (e.key === '2') {
            window.location.href = `/general/appbuilder/web/report/replist/export?id=${this.props.reportId}&type=Yes&category=html&searchParams=${JSON.stringify(this.state.searchParams)}`;
        }
    }

    //明细表打印
    reportPrint() {
        let data = {
            id: this.props.reportId,
            type: 'Yes',
            category: 'html',
            print: 1,
            searchParams: this.state.searchParams
        }
        jQuery.get('/general/appbuilder/web/report/replist/export', { ...data }, function (res) {
            var iframe = document.createElement('IFRAME');
            var doc = null;
            iframe.setAttribute('style', 'position:absolute;width:0px;height:0px;left:-500px;top:-500px;');
            document.body.appendChild(iframe);
            doc = iframe.contentWindow.document;
            doc.write(res);
            doc.close();
            iframe.contentWindow.focus();
            iframe.contentWindow.print();
            if (navigator.userAgent.indexOf("MSIE") > 0) {
                document.body.removeChild(iframe);
            }
        })
    }
    onShowSizeChange(current, pageSize){
        console.log(current, pageSize)
        this.setState({
            pageSize:pageSize,
            page:1
        })
        this.updateData({
            page: 1,
            pageSize: pageSize
        })
    }
    renderTableHeader(){
        let {
            rep_data,
            rep_data_new,
            rep_config:{
                mergeCells
            },
            style,
            tableStyle
        }=this.state
       
        let header=rep_data.slice(0,rep_data_new);
        let thEle= function(j,data){
            let html=[];
            let colNum=-1;
            let length=data.length
           
            data.map((item,z)=>{
                if(z<colNum || length<colNum){
                    return html;
                }
                let objStylr= JSON.parse(JSON.stringify(style))
                if(JSON.stringify(tableStyle.th)!=="{}"){
                    if(tableStyle.th[j+"_"+z]){
                        objStylr=tableStyle.th[j+"_"+z]
                    }
                }
                let isMergeCellBool=false
                if(mergeCells&&mergeCells.length>0){
                    for(var i=0;i<mergeCells.length;i++){
                        // if(mergeCells[i].row===j&&mergeCells[i].col===z){  //横向合并
                        //     isMergeCellBool=true
                        //     colNum=mergeCells[i].colspan+z
                        //     html.push(<th style={objStylr} key={`th_${j}_${z}`} rowSpan={`${mergeCells[i].rowspan}`} colSpan={`${mergeCells[i].colspan}`}>{ item}</th>)
                        // }else if(mergeCells[i].col===z&&mergeCells[i].rowspan>1 &&mergeCells[i].row!==j ){  //纵向合并
                        //     isMergeCellBool=true
                        // }
                        if(mergeCells[i].row===j&&mergeCells[i].col===z&&mergeCells[i].colspan>1){  //横向合并
                            isMergeCellBool=true
                            colNum=mergeCells[i].colspan+z
                            html.push(<td style={objStylr} key={`td_${j}_${z}`} rowSpan={`${mergeCells[i].rowspan}`} colSpan={`${mergeCells[i].colspan}`}>{ item}</td>)
                        }else if(mergeCells[i].row===j&&mergeCells[i].col===z&&mergeCells[i].rowspan>1  ){  //纵向合并
                            isMergeCellBool=true
                            html.push(<td style={objStylr} key={`td_${j}_${z}`} rowSpan={`${mergeCells[i].rowspan}`} colSpan={`${mergeCells[i].colspan}`}>{ item}</td>)
                        }else if(mergeCells[i].col===z&&mergeCells[i].rowspan>1 &&mergeCells[i].row!==j){  //跳过合并列
                            let max=mergeCells[i].rowspan+mergeCells[i].row;
                            if(j>mergeCells[i].row&&j<max){
                                isMergeCellBool=true
                            }

                        }
                    }
                }
                if(!isMergeCellBool){
                    colNum=-1;
                    html.push(<th style={objStylr} key={`${j}_${z}`} >{ item}</th> )
                }
            })
            return html
        }
        
        let trEle = header.map((item, i) => {
            return (
                <tr key={`row_${i}`}>
                    {
                        thEle(i,item)
                    }
                </tr>
            );
            
        });
        return trEle;
        
    }
    renderTableBody(){
        let {
            // rep_data,
            rep_data_new,
            style,
            rep_config,
            megreconfig,
            tableStyle,
            currentPageData
        }=this.state
        // let data=rep_data.slice(rep_data_new);
        let data=currentPageData;
        let mergeCells=megreconfig
        let hash = {}
        mergeCells = mergeCells.reduceRight((item, next) => {  // 去重且修改行下标
            next.key=next.row+"_"+next.col+"_"+next.rowspan+"_"+next.colspan
            // next.row=next.row-rep_data_new
            hash[next.key] ? '' : hash[next.key] = true && item.push(next);
            return item
        }, []);
        function newMerCellFunc(data,preview_new,index){  // index用来判断合并列的下标
            function compareRow(data,col,row,count){
                if(data.length>(row+1)){
                    if(data[row][col]===data[row+1][col]){
                        count+=1,row+=1;
                        return  compareRow(data,col,row,count)
                    }
                }
                return  count;
            }
            let newMerCell=[];
            if(data.length===0){
                return;
            }
            let colLength=data[0].length
            if(index || index===0){
                colLength=index;
            }
            let rowLength=data.length;
            for(let i=0;i<colLength;i++){
                let j=preview_new
                for(;j<rowLength;j++){
                    if(data.length>(j+1)&&data[j][i]!==""&& data[j][i]===data[j+1][i]){//先判断与下一行是否相同,再递归
                        let row=j+1;
                        let count= compareRow(data,i,row,2)
                        let obj={
                            row: j,
                            col: i,
                            rowspan: count,
                            colspan: 1,
                        }
                        newMerCell.push(obj)
                        j=count+j-1;
                    }
                }
            }
           return newMerCell
        }
        // mergeCells=newMerCellFunc(data,0);
        console.log(mergeCells)
        let tdEle= function(j,data){
            let html=[];
            let colNum=-1;
            let length=data.length
           
            data.map((item,z)=>{
                if(z<colNum || length<colNum){
                    return html;
                }
                let objStylr= JSON.parse(JSON.stringify(style))
                if(JSON.stringify(tableStyle.td)!=="{}"){
                    if(tableStyle.td[rep_data_new+"_"+z]){
                        objStylr=tableStyle.td[rep_data_new+"_"+z]
                    }
                    
                }
                if(j===0){     
                    objStylr.width= rep_config.colWidths[z]+"px";
                }
                
                let isMergeCellBool=false
                if(mergeCells&&mergeCells.length>0){
                    for(var i=0;i<mergeCells.length;i++){
                        if(mergeCells[i].row===j&&mergeCells[i].col===z&&mergeCells[i].colspan>1){  //横向合并
                            isMergeCellBool=true
                            colNum=mergeCells[i].colspan+z
                            html.push(<td style={objStylr} key={`td_${j}_${z}`} rowSpan={`${mergeCells[i].rowspan}`} colSpan={`${mergeCells[i].colspan}`}>{ item}</td>)
                        }else if(mergeCells[i].col===z&&mergeCells[i].rowspan>1 &&mergeCells[i].row===j ){  //纵向合并
                            isMergeCellBool=true
                            html.push(<td style={objStylr} key={`td_${j}_${z}`} rowSpan={`${mergeCells[i].rowspan}`} colSpan={`${mergeCells[i].colspan}`}>{ item}</td>)
                        }else if(mergeCells[i].col===z&&mergeCells[i].rowspan>1 &&mergeCells[i].row!==j){  //跳过合并列
                            let max=mergeCells[i].rowspan+mergeCells[i].row;
                            if(j>mergeCells[i].row&&j<max){
                                isMergeCellBool=true
                            }

                        }
                        
                    }
                }
                if(!isMergeCellBool){
                    colNum=-1;
                    html.push(<td style={objStylr} key={`${j}_${z}`} >{ item}</td> )
                }
            })
            return html
        }
        let trEle = data.map((item, i) => {
            return (
                <tr key={`tr_${i}`} className="ant-table-row">
                    {
                        
                        tdEle(i,item)
                    }
                </tr>
                
            );
            
        });
        return trEle;
        
    }
    render(){
        const me = this;
        const exportMenu = (
            <Menu onClick={this.handleExportMenuClick.bind(this)}>
                <Menu.Item className="ui-detail-export-excel" key="1">导出Excel</Menu.Item>
                <Menu.Item className="ui-detail-export-html" key="2">导出Html</Menu.Item>
            </Menu>
        );
        let {page}=this.state
        let showName = this.props.showName ? true : false
        let showSearchParams = this.props.showSearchParams ? true : false
        let showExport = this.props.showExport ? true : false
        let showPrint = this.props.showPrint ? true : false
        let showElId = this.props.el ? this.props.el.toString():'';
        const container = (
            <div id="myRepDetail">
                <div className="td-cmp-option">
                    {
                        showExport? <Dropdown overlay={exportMenu}><Button>导出 <Icon type="down" /></Button></Dropdown> : null
                    }
                    {
                        showPrint ? <Button className="ui-detail-print-btn" onClick={this.reportPrint.bind(this)}>打印</Button> : null
                    }
                </div>
                <Row  type="flex" justify="center">
                    <Col>
                        <TdCmpName visible={showName} title={this.state.name} />
                        <Row type="flex" justify="center" align="middle">
                        <Col>
                            <div className="td-cmp-content">
                                {
                                    /* me.state.count.length > 0 ? <Button type="primary" onClick={this.handlerCalc.bind(this)}>计算</Button>:null */
                                }
                                <div>
                                {
                                    showSearchParams && this.state.searchParams.length ? <SearchFields selec_data={this.state.selec_data} searchParams={this.state.searchParams} onSearch={this.onSearch.bind(this)} /> : null
                                }
                                </div>
                                    <div id={this.state.showElIdRef} ref={this.state.showElIdRef} className="preview" style={{"margin":"10px 0px"}}>
                                    <div   className=" ant-table ant-table-default ant-table-large ant-table-bordered ">
                                        <div className="ant-table-content">
                                            <div className="ant-table-body">
                                                    <table >
                                                        <thead className="ant-table-thead">
                                                            {this.renderTableHeader()}
                                                        </thead>
                                                        <tbody className="ant-table-tbody">
                                                            {this.renderTableBody()}
                                                        </tbody>
                                                    </table>
                                            </div>
                                        </div>
                                    </div>
                                    </div>
                                
                            </div>
                        </Col>
                        </Row>
                    </Col>
                </Row>
                {
                    me.state.total > 0 ?
                    <div className="clearfix">
                        <Pagination style={{"float":"left","marginLeft": "10px"}}  current={this.state.page} showSizeChanger  pageSizeOptions={['5','10','15','20']} onChange={this.onChange.bind(this)}   onShowSizeChange={(current, pageSize)=>me.onShowSizeChange(current, pageSize)} pageSize={me.state.pageSize} total={me.state.total} />
                        <span className="pull-right" style={{"float":"left","lineHeight": "28px","marginLeft": "10px"}}>共{me.state.total}条数据</span>

                    </div>
                    :null
                }
            </div>
        )
        let rep_name = this.state.name ? this.state.name : ''
        return this.state.isError ? <Alert
                            message={`“${rep_name}”加载失败`}
                            description={`reportId: ${this.props.reportId} ${this.state.errorText}`}
                            type="info"
                            style={{ marginBottom: 16 }}
                        /> : 
                        <Spin spinning={this.state.loading}>
                        
                       
                        {container}
                        </Spin>
    }
    onSearch(searchParams){
        this.setState({
            searchParams
        },()=>{
            this.getShowData({
                page: 1,
                type: 'Yes',
                cacheType: false
            })
        })
    }
    onChange(page){
        this.setState({
            page,
            loading:true
        })
        this.updateData({
            page: page,
            type: 'Yes',
            cacheType: true
        })
    }
    handlerCalc(){
        this.updateData({
            page: 1,
            type: 'count',
            cacheType: false
        })
    }
    componentDidMount(){
        let firstLoad = true
        this.getShowData({
            page: 1,
            type: 'Yes',
            cacheType: false
        })
    }
    updateData(params){
        const me = this
        let { rep_tbodyData,pageSize,page } = this.state
        if(params.pageSize){
            pageSize=params.pageSize
        }
        if(params.page){
            page=params.page
        }
        
        let currentPageData=rep_tbodyData.slice(pageSize*(page-1) ,pageSize*page);
        let rowtocoldata = getPreNewData(currentPageData)//报表数据的新数据行转换为列
                let finalldata = rowtocoldata[0] ? [rowtocoldata[0]] : [];//报表数据的新数据的合并信息
                for(let j = 1; j < rowtocoldata.length; j ++ ){
                    let temArr = megMatchCol(rowtocoldata[j-1],rowtocoldata[j])//根据前一列获取后一列的合并数据
                    rowtocoldata[j] = temArr
                    if (rowtocoldata[j] !== undefined ){
                        finalldata.push(rowtocoldata[j])
                    }
                }
        let megreconfig = getMergCfg(finalldata,0)//报表数据的新数据的合并信息装换为合并配置数据 

        if(open_number!==undefined){//判断是否开启编号
            currentPageData.forEach(function(item,index){
                    item.unshift((index+1)+((page-1)*20))//添加编号
            })
            megreconfig.forEach(function(item,index){
                item.col+=1;
            })
        }     
        this.setState({
            currentPageData:currentPageData,
            megreconfig:megreconfig,
            loading: false,

        })
        
    }

    isPC() {
        var userAgentInfo = navigator.userAgent;
        var Agents = new Array("Android", "iPhone", "SymbianOS", "Windows Phone", "iPad", "iPod", "webOS");
        var flag = true;
        for (var v = 0; v < Agents.length; v++) {
            if (userAgentInfo.indexOf(Agents[v]) > 0) { flag = false; break; }
        }
        return flag;
    }
    //调整明细表居中情况
    adjustStyleCenter () {
        let self = this;
        if(self.isPC()){
            if (jQuery('#preview .wtHolder  table.htCore').width() < 700) {
                jQuery('#preview .wtHolder').css({ 'width': 'auto !important;' })
                jQuery('#preview .wtHolder').addClass('preview-wrapper-wtHolder')
            }
        }
    }
    getShowData(params){
        const me = this
        const reportId = this.props.reportId
        const { link_type, slot } = this.state
        let { page,type,cacheType } = params
        let { searchParams } = this.state

        jQuery.ajax({
            method: "post",
            url: "/general/appbuilder/web/report/replist/showdata",
            data: { 
                id: reportId, 
                type: type, 
                page: page, 
                cacheType: cacheType,
                pageSize:20,
                // searchParams:JSON.stringify(searchParams),
                link_type:link_type,
                slot:slot
            },
            async: true  // 修改成异步加载  
        }).done(function (response) {
            const { status, data } = response
            if (status != 'ok') {
                me.setState({
                    isError: true,
                    loading: false,
                    errorText: response.msg ? response.msg : '请求该明细表数据失败！',
                    name:response.name
                })
                message.error(response.msg)
            } else {
                let {
                    name,
                    rep_data,
                    rep_config,
                    db,
                    guid,
                    cache_span,
                    rep_data_new, 
                    page,
                    data_type,
                    count,
                    searchParams,
                    selec_data,
                    open_number,
                    table_style,
                } = data
                
                rep_data = rep_data ? rep_data : [];
                rep_config = rep_config ? rep_config : {};
                let params1 = {
                    data : rep_data,
                    config : data_type,
                    begin : rep_data_new
                }
                rep_data = handleDataToOuYuan(params1);
                myRepDetailNewDataBegin = rep_data_new
                let newdata = rep_data_new //报表数据的新数据起始行数
                let datalenght = rep_data.length //报表数据的新数据行数
                let predata = rep_data//报表数据
                let temdata = []//报表数据的新数据
                if((datalenght - newdata -1 ) > 0 ){
                    for(let i= newdata;i<datalenght;i++){
                        temdata.push(predata[i])
                    }
                }
               
                me.adjustStyleCenter()
                let newSearchParams = searchParams.filter(function (elem) {
                    if(elem.type_of_reports === 'search'){
                        return elem;
                    }
                })
                if(table_style===""){
                    table_style=me.state.tableStyle;
                }
                me.setState({
                    name,
                    rep_data,
                    rep_config,
                    db,
                    guid,
                    cache_span,
                    rep_data_new, 
                    total:temdata.length,
                    count,
                    searchParams:newSearchParams,
                    selec_data,
                    open_number,
                    tableStyle:table_style,
                    rep_tbodyData:temdata
                })  
                me.updateData({
                    page: 1,
                    type: 'Yes',
                    cacheType: false
                }) 
            }
        }).fail(function (e) {
            me.setState({
                isError: true,
                errorText: e.responseText,
                loading: false
            })
        });
    }
}

export default Detail


//把预览数据中的查询出来的数据处理为有合并信息的数据
function getPreNewData(data) {
	var rows = data.length;//数据的行数
	var cols = 0;//数据的列数
	if (data.length > 0) {
		cols = data[0].length;
	}
	var colTorow = [];//因为根据前一列处理后一列的数据，所以为了需要，先把列转为行

	for (let j = 0; j < cols; j++) {
		var tmp = [];
		for (let i = 0; i < rows; i++) {
			tmp.push({
				row: i,
				col: j,
				data: data[i][j]
			})
		}
		colTorow.push(tmp)
	}

	var f1 = [],//一行中可合并的数据
		f2 = [],// 每一行的数据
		f3 = false,
		f4 = 'undefinedasdasdsaaaaaaaaaaaaaaaaaaaaaaaaaaaaa',
		f5 = []//最后得到的合并数据
	for (let j = 0; j < cols; j++) {
		for (let [index, elem] of colTorow[j].entries()) {
			if (f4 == elem.data && f3 == elem.col) {//前一个数据与后一个相同则放入一个数组中，同一个数组意味着可合并
				if ((f1[f1.length - 1] + 1) == index) {
					f1.push(index)
                }
                
			} else {
				f3 = elem.col
				f4 = elem.data
					if (f1.length > 0) {
						f2.push(f1)
					}
					f1 = []
				f1.push(index)
            }
		}
		f2.push(f1)
		f5.push(f2)
		f1 = []
		f2 = []
	}
	return f5
}


//根据前一个合并的数据处理：前一列的合并数目应大于等于后一列的数据
function megMatchCol(data1, data2) {
	let arr = []
	data1.forEach(function (eles, index) {
		let ele = eles.join(',')
		data2.forEach(function (items, num) {
			let item = items.join(',')
			if (ele.indexOf(item) != -1) {
				arr.push(items)
			} else if (Array.intersect(eles, items).length > 0) {
				arr.push(Array.intersect(eles, items))
			}
		})
	});
	return arr
}

//根据前一个得到的合并数据，处理为handsontable的合并配置数据
function getMergCfg(data,newdata) {
    let mgcfg = [] 
    if(data){
        data.forEach(function (item, index) {
            if (item.length >= 1) {
                item.map(function (ele, idx) {
                    if (ele.length > 1) {
                        mgcfg.push({
                            row: ele[0]+parseInt(newdata),
                            col: index,
                            rowspan: ele.length,
                            colspan: 1
                        })
                    }
                })
            }
        })        
    }
	return mgcfg
}


function handleDataToOuYuan(params) {
    let { config, data ,begin } = params
    let locaArr = [];
    let ouYuan = "€"
    config.forEach((v,i) => {
        if(v.money && v.money.money_type && v.money.money_type === "O"){
            locaArr.push(v.id);
        }
    })
    let dataArr = data;

    locaArr.forEach((v,i) => {
        dataArr.forEach(( elem, idx ) => {
            if(idx >= (begin-1)){
                elem[v] = elem[v].replace(/O/, "€")
            }
        })
    })

    return  dataArr
}